TYPO3.Flow - Bug #39300

Bug # 37574 (Resolved): ReflectionData is not regenerated automatically

blocking ReflectionService: Call to a member function get() on a non-object
2012-07-26 17:05 - Adrian Foder

Status: Closed Start date: 2012-07-26
Priority: Won't have this time Due date:

Assignee: % Done: 0%
Category: Reflection Estimated time: 0.00 hour
Target version: 1.1.1

PHP Version: Complexity:

Has patch: No

Description

Most is commented in https://review.typo3.org/#/c/12575/, however a few steps to (hopefully) reproduce:

L]

Use a full Phoenix, all on current master, especially with 12575 applied.

make sure also the FLOWS subroutes are included, not only the TYPOS ones.

run “phpunit --debug -c Build/Common/PhpUnit/FunctionalTests.xml
Packages/Framework/TYPO3.FLOW3/Tests/Functional/Http/RequestHandlerTest.php’

this should result in the message "PHP Fatal error: Call to a member function get() on a non-object in
/var/www/Packages/Framework/TYPO3.FLOW3/Classes/Reflection/ReflectionService.php on line 987".
¢ maybe, try to call your frontend without any given route; in my case this results in the same error.

History

#1 - 2012-07-26 17:27 - Adrian Foder
OK, Core\Booting\Scripts.php::initializeReflectionService(), line 319:

SreflectionService->setClassSchemataRuntimeCache ($cacheManager->getCache ('FLOW3_Reflection_RuntimeClassSchemat
a'));

that cache is empty in my case; actually, both
/Data/Temporary/Testing/Cache/Data/FLOW3_Reflection_RuntimeClassSchemata/
/Data/Temporary/Testing/Cache/Data/FLOW3_Reflection_RuntimeData/

directories are empty...

Will examine further.

#2 - 2012-07-26 18:07 - Adrian Foder

an additional note; the call stack mentioned in the review; https:/raw.qgithub.com/gist/3046718/, looks like it has something to do with Widget stuff
which explains why it is so hard to reproduce: it does only occur in the mentioned Functional test; or if your frontend uses Widgets. Both is the case in
my case.

#3 - 2012-07-27 10:17 - Adrian Foéder

new Stuff: again, the line in question is the following:

public function getClassSchema ($classNameOrObject) {

if (!isset ($this->classSchemata[$className])) {
// the following get () fails due to "on a non-object"
$this->classSchemata[$className] = $this->classSchemataRuntimeCache->get (str_replace('\\', '_',

SclassName)) ;

}

interestingly, the ->classSchemata array is fully empty in that case! Having examined the initialize() and every other method involved, everything
looks good regarding the classSchemata being populated with the correct data.

But, when the error happens, the $this->context is TYPO3\FLOW3\Reflection\ReflectionService! also the systemLogger, for example, is empty; which
leads me to the conclusion that the initialize() method is not invoked in the error case.

To verify this; | added a protected helper variable that | changed in the initialize() method; and it doesn't become changed -> the initialize() doesn't get
executed.
It looks like there are multiple instances of the ReflectionService around, not being all the exact same ones.

#4 - 2012-07-27 15:00 - Bastian Waidelich
Hi Adrian,
| tried to reproduce this, but without success:

If I run the functional test without including the FLOW3 sub routes | get

There was 1 skipped test:

1) TYPO3\FLOW3\Tests\Functional\Http\RequestHandlerTest::httpRequestIsConvertedToAnActionRequestAndDispatchedT
oTheRespec

tiveController

In this distribution the FLOW3 routes are not included into the global configuration.

OK, but incomplete or skipped tests!
Tests: 1, Assertions: 0, Skipped: 1.

..as expected.

If I include the FLOWS routes by adding

i
# FLOW3 subroutes

name: 'FLOW3'
uriPattern: '<FLOW3Subroutes>'

defaults:
'@format': 'html'

subRoutes:
FLOW3Subroutes:

package: TYPO3.FLOW3

at the end or beginning of the global Configuration/Routes.yaml | get
Time: 15 seconds, Memory: 49.50Mb
OK (1 test, 1 assertion)

(PHP 5.4, Win7 64bit)

#5 - 2012-07-27 15:35 - Adrian Foder
- Status changed from New to Needs Feedback
- Assignee set to Adrian Féder

- Priority changed from Must have to Should have

Hi Bastian,
thanks a lot for your testing; I'm also currently just up to find more information about how to reproduce this. The whole thing looks pretty weird...
I'll update as soon as | find some more information.

#6 - 2012-07-27 16:11 - Bastian Waidelich
Adrian Foder wrote:
I'm also currently just up to find more information about how to reproduce this. The whole thing looks pretty weird...

I'll update as soon as | find some more information.

Thank you! It would be really good if we could solve that before 1.1 final..
Maybe the problem is related to some multi threading issue.. What is your setup?

#7 - 2012-07-27 17:03 - Adrian Foder
well, we have a hosted Xen virtual machine; | don't know much further.... what exactly do you want to know?

At my local windows the error so far is also not reproducable, just like yours. Now I'm up to check whether | can reproduce that in a real very fresh
environment...

#8 - 2012-07-30 09:34 - Adrian Foder
- Assignee changed from Adrian Féder to Bastian Waidelich

ok, with a step-by-step comparison | found out what was triggering the error: it was my ElasticSearch package, to be concrete it was solved when
removing these following lines: https:/github.com/afoeder/TYPQOS3.ElasticSearch/blob/master/Classes/Package.php#L 37

When looking at it it's obvious that it's very likely because some handling with the object manager at an early step happens.

So what | finally would like to know is, would you say such occurrence would make the initial change breaking, or am | doing something wrong in my
code anyways?

#9 - 2012-08-17 11:19 - Karsten Dambekalns

- Target version changed from 1.1 to 1.1.1

#10 - 2012-08-17 11:35 - Adrian Féder
- Status changed from Needs Feedback to Closed
- Assignee deleted (Bastian Waidelich)

- Priority changed from Should have to Won't have this time

This seems having went away... will observe this of course, but for now disregard this.
